#include <ESP8266WiFi.h>

const char* ssid = "SynBoxLAN"; // your SSID
const char* password = "Tektronix18"; // your password

#define GPIO0 0 // On or off

WiFiServer server(80);

void setup()
{
  Serial.begin(115200);
  pinMode(GPIO0, OUTPUT);
  digitalWrite(GPIO0, LOW);

  // Connect to WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected");

  // Start the server
  server.begin();
  Serial.println("Server started");

  // Print the IP address
  Serial.print("Use this URL to connect: ");
  Serial.print(WiFi.localIP());
  Serial.println("/");
}

void loop()
{
  // Check if a client has connected
  WiFiClient client = server.available();

  if (!client)
  {
    return;
  }

  // Wait until the client sends some data
  Serial.println("new client");
  while (!client.available())
  {
    delay(1);
  }

  // Read the first line of the request
  String request = client.readStringUntil('\r');
  Serial.println(request);
  client.flush();

  // Match the request
  int value = LOW;
  if (request.indexOf("/GPIO0=ON") != -1)
  {
    Serial.println("GPIO0=ON");
    digitalWrite(GPIO0, HIGH);
    value = HIGH;
  }
  else if (request.indexOf("/GPIO0=OFF") != -1)
  {
    Serial.println("GPIO0=OFF");
    digitalWrite(GPIO0, LOW);
    value = LOW;
  }

  // Return the response
  client.println("HTTP/1.1 200 OK");
  client.println("Content-Type: text/html");
  client.println(""); // this is a must
  client.println("<!DOCTYPE HTML>");
  client.println("<html>");
  client.println("<head><title>ESP01 GPIO0 Control</title></head>");
  client.print("GPIO0 is now: ");
  if (value == LOW)
  {
    client.print("OFF");
  }
  else
  {
    client.print("HIGH");
  }
  client.println("<br><br>");
  client.println("Turn <a href=\"/GPIO0=ON\">ON</a><br>");
  client.println("Turn <a href=\"/GPIO0=OFF\">OFF</a><br><br>");
  client.println("</html>");
  delay(1);
  Serial.println("Client disonnected");
  Serial.println("");
}
